/* Program  exch.cc          */
/* By Harald Stauss          */
/* Last change 3. March 1997 */
/* g++ -o exch exch.cc       */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <iomanip.h>
#include "tsa.h"
#include "nrc/nrutil.h"
#include "nrc/nrutil.c"

main(int argc, char *argv[]) {
  short    i;
  unsigned long n;
  char     *fin, *fout, *dout, *ftin, *pftin, *fout2;
  REGIST   r;
  ofstream ausdat;

  /*  H e l l o    w o r l d   */

  printf("EXCH Ver.1.0 by H. Stauss, 1997 \n");
  fin  =(char *)malloc(255); 
  ftin =(char *)malloc(255);
  fout =(char *)malloc(255);
  dout =(char *)malloc(255);
  fout2=(char *)malloc(255);

  /* P a r a m e t e r   e i n l e s e n */

  if (argc != 4)
    {
      printf("Number of parameters wrong! \n");
      printf("Extract channels only for human project \n");
      printf("exch fin dirout fout \n");
      printf("fin    : name of input file (*.asc or *.tsa). \n");
      printf("dirout : directory for output file. \n");
      printf("fout   : name of output file (*.asc or *.tsa). \n");
      goto ende;
    }
  strcpy(fin,argv[1]);
  strcpy(ftin,fin);
  pftin=strrchr(ftin,'.');
  for (i=0; pftin[i]; i++) pftin[i]=toupper(pftin[i]);
  strcpy(dout,argv[2]);
  strcpy(fout,argv[3]);

  /* E i n g a b e d a t e i e n   o e f f n e n */
  if (strcmp(pftin,".TSA")==0) r.ReadTSA(fin);
  if (strcmp(pftin,".ASC")==0) r.ReadASCII(fin,1);
  if ((strcmp(pftin,".TSA")!=0) && (strcmp(pftin,".ASC")!=0)) {
    cout << "File type for input file not recognized! \n";
    goto ende;
  }
  cout << "input file:         " << fin << "\n";
  cout << "number of channels: " << r.n << "\n";

  for (i=1; i<r.n; i++) {
    strcpy(fout2,dout);
    if (i==1) strcat(fout2,"/bp/");
    if (i==2) strcat(fout2,"/sbf1/");
    if (i==3) strcat(fout2,"/resp/");
    if (i==4 && r.n==6) strcat(fout2,"/sbf2/");
    if (i==4 && r.n==5) strcat(fout2,"/hr/");
    if (i==5 && r.n==6) strcat(fout2,"/hr/");
    strcat(fout2,fout);
    cout << "output file:        " << fout2 << "\n";
    /*   A u s g a b e d a t e i   o e f f n e n   */
    ausdat.open(fout2);
    if (!ausdat) {
      cout << "file could not be opened for output!\n";
      goto ende;
    }
    for (n=0; n<r.ch[i].n; n++) {
      ausdat << r.ch[i].data[n] << "\n";
    }
    ausdat.close();
  }

 ende:
  free(fin); free(ftin); free(fout); free(fout2); free(dout);
  return 0;
} // ende des programms;
